<?php
// イベント表示出来るミニカレンダー
// outlook csv インポート機能アリます
//
// このファイルは編集する必要はありません

// --------------------
// 基本変数の仕様
// $ymd[0]	= 年月
// $ymd[1]	= 年
// $ymd[2]	= 月
// $ymd[3]	= 本日
// $ymd[4]	= 先月(年)
// $ymd[5]	= 来月(年)
// $ymd[6]	= 先月
// $ymd[7]	= 来月

// --------------------
// 引数判定 (無い場合は本日が基準)
function argumentCheck(){
	if( !empty($_SERVER['QUERY_STRING']) && preg_match( "/^[0-9]{6}/", $_SERVER['QUERY_STRING'] ) ){
		$ymd[0] = substr( $_SERVER['QUERY_STRING'], 0, 6 );
		$ymd[1] = substr( $_SERVER['QUERY_STRING'], 0, 4 );
		$ymd[2] = substr( $_SERVER['QUERY_STRING'], 4, 2 );
		if( $ymd[1] == date("Y") && $ymd[2] == date("n") ) $ymd[3] = date("j");
	}else{
		$ymd[0] = date("Ym");
		$today = getdate();
		$ymd[1] = $today['year'];
		$ymd[2] = sprintf( "%02d", $today['mon'] );
		$ymd[3] = $today['mday'];
	}
	$ymd[4] = date("Ym", mktime(0,0,0,$ymd[2],0,$ymd[1]));
	$ymd[5] = date("Ym", mktime(0,0,0,$ymd[2]+1,1,$ymd[1]));
	$ymd[6] = date("m", mktime(0,0,0,$ymd[2],0,$ymd[1]));
	$ymd[7] = date("m", mktime(0,0,0,$ymd[2]+1,1,$ymd[1]));
	return $ymd;
}

// --------------------
// 週休指定読み込み
function weekly_holiday(){
	$list = array();
	foreach( file(WEEKLY) as $key => $val ){
		$list[rtrim($val)] = true;
	}
	return $list;
}

// --------------------
// 祝日、イベントの読み込み
function holidays($fname){
	$list = array();
	foreach( file($fname) as $val ){
		$tmp = explode( ',', $val );
		$list[rtrim($tmp[0])] = empty($tmp[1]) ? "" : rtrim($tmp[1]);
	}
	return $list;
}

// --------------------
// カレンダーフォーム
function calendar($ymd){
	global $week,$holiday,$event,$weekly,$font_size,$col_sunday,$col_saturday,$col_weekday,$col_holiday,$col_event,$col_bg,$col_line;

	$fast = getdate( mktime(0,0,0,$ymd[2],1,$ymd[1]) );
	$weekcount = $fast['wday'];

	// ここから出力データの準備
	$html = "";
	$html .= "<table cellspacing=\"0\" cellpadding=\"6\" style=\"background-color:$col_bg;border-collapse:collapse;font-size:$font_size;\" class=\"wrap\">\n";
	$html .= "<tr><td nowrap colspan=\"7\">\n";
	$html .= "<a href=\"?$ymd[4]\" class=\"button arrowL\">${ymd[6]}月</a>\n";
	$html .= "&nbsp;<b>$ymd[1]</b>年<b>$ymd[2]</b>月&nbsp;\n";
	$html .= "<a href=\"?$ymd[5]\" class=\"button arrowR\">${ymd[7]}月</a></td></tr>\n";

	$html .= "<tr>";
	foreach( $weekly as $key => $val ){
		$html .= "<td style=\"border:1px solid $col_line;color:";
		if( 0 == $key ) $html .= $col_sunday;
		else if( 6 == $key ) $html .= $col_saturday;
		else $html .= $col_weekday;
		$html .= ";\">$val</td>\n";
	}
	$html .= "</tr>\n";

	if( $weekcount ) $html .= "<tr>\n";

	// パディング用のマス
	for( $i = 0; $i < $weekcount; $i++ ){
		$html .= "<td style=\"border:1px solid $col_line;\">&nbsp;</td>\n"; 
	}

	$day = 0;
	while( true ){
		if( !$weekcount ){ $html .= "<tr>"; }

		$weekcount++;
		$day++;
		$target = $ymd[0] . sprintf( "%02d", $day );

		// 本日の場合は強調文字
		if( isset($ymd[3]) && $day == $ymd[3] ){
			$bold = "font-weight:bold;";
		}else{
			$bold = "";
		}

		// 背景色の指定
		if( isset($holiday[$target]) || isset($week[$weekcount]) ){
			$bg_col = "background-color:$col_holiday;";
		}else if( isset($event[$target]) ){
			$bg_col = "background-color:$col_event;";
		}else{
			$bg_col = "";
		}

		// 文字色の指定
		if( 1 == $weekcount ){
			$txt_col = "color:$col_sunday;";
		}else if( 7 == $weekcount ){
			$txt_col = "color:$col_saturday;";
		}else{
			$txt_col = "color:$col_weekday;";
		}

		// データが有れば、吹き出し設定
		$html .= "<td style=\"border:1px solid $col_line;$txt_col$bg_col$bold\"><p>$day";
		if( !empty($holiday[$target]) ){
			$html .= "<span>$holiday[$target]</span>";
		}else if( !empty($event[$target]) ){
			$html .= "<span>$event[$target]</span>";
		}else if( !empty($week[$weekcount]) ){
			$html .= "<span>" . REGULAR . "</span>";
		}
		$html .= "</p></td>\n";

		// 折り返し
		if( 7 == $weekcount ){
			$html .= "</tr>\n";
			$weekcount = 0;
		}

		// 月間越えたら終了
		if( !checkdate($ymd[2], $day+1, $ymd[1]) ) break;
	}
	$html .= "</table>\n";

	return $html;
}


// 設定ファイルの取り込み
$ymd = argumentCheck();
$week = weekly_holiday();
$holiday = holidays(HOLIDAY);
$event = holidays(EVENT);



// Text by Exist-Zero,Inc.
// 2017/01/01
?>
