<?php
// イベント表示出来るミニカレンダー
// outlook csv インポート機能アリます

require_once( "lib/myCustom.php" );
require_once( "lib/myCommon.php" );


// ----------------
// ここだけの基本設定
defined('EXIST_ZERO')	or define('EXIST_ZERO',	'ez');
defined('MY_COUNTDOWN')	or define('MY_COUNTDOWN', 1200);
defined('MYLAST')		or define('MYLAST',		'myExpire');
defined('MYTARGET')		or define('MYTARGET',	'myTarget');
defined('MYUSER')		or define('MYUSER',		'myUser');
defined('MYPASS')		or define('MYPASS',		'myPass');

// ----------------
$MY_FILE = basename($_SERVER['PHP_SELF']);

$output = false;

// ----------------
$NowTime = time();

// ================
if( ! class_exists('myBootstrap') ){
class myBootstrap
{
	// session controll Wakeup
	static public function startup(){
		if( version_compare(phpversion(), '5.4.0', '>=') ) {
			if( PHP_SESSION_ACTIVE == session_status() ) return;
		}else{
			if( '' !== session_id() ) return;
		}

		session_id(EXIST_ZERO);
		session_cache_limiter('nocache');
		session_cache_expire(0);
		session_start();
	}

	// session controll Getout
	static public function shutdown(){
		unset( $_SESSION[MYLAST], $_SESSION[MYPASS] );
		session_write_close();
		session_start();
		session_destroy();
	}

	// Web argument pickup
	static public function get_param( $key ){
		return filter_input( INPUT_POST, $key );
	}

	// File backup & write
	static public function outputer( $fname, $data, $opt = true ){
		rename( $fname, substr( $fname, 0, 1 + strrpos( $fname, '.' ) ) . "bak" );
		if( false !== ($fp = fopen($fname, "w+")) ){
			foreach( $data as $key => $val ){
				$tmp = $key;
				if( $opt ) $tmp .= ",".$val;
				$tmp .= "\n";
				fputs($fp, $tmp);
			}
			fclose($fp);
		}
	
	}

}// class myBootstrap
}// ! class_exists('myBootstrap')



// ================
	myBootstrap::startup();

// ----------------
// 引数優先
if ( ! is_null($tmp = myBootstrap::get_param( "User" )) )	$_SESSION[MYUSER] = $tmp;
if ( ! is_null($tmp = myBootstrap::get_param( "Passwd" )) )	$_SESSION[MYPASS] = $tmp;

// ----------------
// セッション情報
if ( empty($_SESSION[MYLAST]) ){
	$_SESSION[MYLAST] = $NowTime + MY_COUNTDOWN;// expire time
}
$user = isset($_SESSION[MYUSER]) ? $_SESSION[MYUSER] : null;
$pass = isset($_SESSION[MYPASS]) ? $_SESSION[MYPASS] : null;

// ----------------
$mesg = "";
$gate = false;
$html = $header;
$html .= "<h2>管理画面</h2>";
if( ! empty($user) && ! empty($pass) ){// 確認
	if( !empty($support[$user]) ){
		if( $pass == $support[$user] ){
			$gate = true;// 合致
		}else{
			$mesg = "ユーザー名またはパスワードが違います";
		}
	}
	// でも、タイムアウトしていたらログイン却下
	if ( $NowTime > $_SESSION[MYLAST] ){
		myBootstrap::shutdown();
		myBootstrap::startup();
		$mesg = "接続期限が切れました";
		$gate = false;
	}else{
		$_SESSION[MYLAST] = $NowTime + MY_COUNTDOWN;// expire time 延長
	}
}

// ----------------
if( !empty($_SERVER['QUERY_STRING']) ){
	if( preg_match( "/^logout/", $_SERVER['QUERY_STRING'] ) ){
		$gate = false;// ログアウト
	}
	argumentCheck();
}

// ----------------
if( !$gate ){
	$html .= "<div align=\"center\">\n";
	$html .= "<form novalidate method=\"post\" action=\"login.php?${ymd[0]}\" id=\"gaia_loginform\">\n";
	$html .= "<br />\n";
	$html .= "<input id=\"User\" name=\"User\" type=\"email\" placeholder=\"アカウント\" value=\"${user}\" spellcheck=\"false\" class=\"\">\n";
	$html .= "<br />\n";
	$html .= "<input id=\"Passwd\" name=\"Passwd\" type=\"password\" placeholder=\"パスワード\" class=\"\">\n";
	$html .= "<br />\n";
	$html .= "<p>${mesg}</p><br />\n";
	$html .= "<input id=\"signIn\" name=\"signIn\" class=\"btn parent_setting\" type=\"submit\" value=\"ログイン\">\n";
	$html .= "</form>\n";
	$html .= "</div>\n";
	$html .= $footer;
	die( $html );
}

// ----------------
	session_write_close();

	myBootstrap::startup();


// ================
if( !empty($_FILES) && is_uploaded_file($_FILES["datafile"]["tmp_name"]) ){
	// アップロードされたファイルの取り込み
	if( "csv" != strtolower(pathinfo($_FILES["datafile"]["name"], PATHINFO_EXTENSION)) ){
		//拡張子を判定
		$mesg = 'CSVファイルのみ対応しています。';
	}else{
		$tmp = file( $_FILES["datafile"]["tmp_name"] );// PHP5.3 は fgetcsv で文字化けするので
		$list = array();
		foreach( $tmp as $data ){
			$line = mb_convert_encoding( $data, 'UTF-8', 'SJIS' );
			$column = explode( ',', $line );
			$ans = array();
			foreach( $column as $key => $val ){
				if( 7 <= $key ) break;// 後半の情報要らない
				$ans[$key] = str_replace("\"", "", $val);
			}
			$list[] = $ans;
			unset($column, $ans);
		}

		if( 1 >= count($list) ){
			$mesg = "予定が無い様です";
		}else{
			foreach( $list as $key => $val ){
				if( 0 == $key ) continue;// カラム情報・スキップ
				$tmp = "";
				foreach( $val as $kk => $vv ){
					if( "件名" == $list[0][$kk] ){
						$tmp = $vv;
					}else if( "開始日" == $list[0][$kk] ){
						$day = explode( '/', $vv );
						$day = sprintf("%4d%02d%02d", $day[0], $day[1], $day[2] );
						if( empty($_POST["select"]) || "H" == $_POST["select"] ){
							$holiday[intval($day)] = empty($tmp) ? "" : $tmp;
						}else if( "E" == $_POST["select"] ){
							$event[intval($day)] = empty($tmp) ? "" : $tmp;
						}
					}
				}
			}
			$output = true;
		}
		unset($list);
	}
}
// ----------------
// 週休判定
if( !empty($_POST["upd"]) ){
	$after = array();
	foreach( $weekly as $key => $val ){
		$tmp = intval($key + 1);
		if( !empty($_POST["week".$tmp]) ){
			$after[$tmp] = true;
		}
	}
	$week = $after;
	$output = true;
}

// ----------------
// 削除判定
foreach( $holiday as $key => $val ){
	if( !empty($_POST["del".$key]) ){
		unset($holiday[$key]);
		$output = true;
	}
}
foreach( $event as $key => $val ){
	if( !empty($_POST["evd".$key]) ){
		unset($event[$key]);
		$output = true;
	}
}

// ----------------
// 自由入力
if( !empty($_POST["add"]) && !empty($_POST["target"]) ){
	if( checkdate(
			intval(substr($_POST["target"], 4, 2)),// month
			intval(substr($_POST["target"], 6, 2)),// day
			intval(substr($_POST["target"], 0, 4))// year
		) ){
		if( empty($_POST["select"]) || "H" == $_POST["select"] ){
			$holiday[$_POST["target"]] = empty($_POST["memo"]) ? "" : $_POST["memo"];
			ksort($holiday);
		}else if( "E" == $_POST["select"] ){
			$event[$_POST["target"]] = empty($_POST["memo"]) ? "" : $_POST["memo"];
			ksort($event);
		}
		$output = true;
	}
}

// ================
// ファイル出力
if( $output ){
	// ------------
	// 週休
	myBootstrap::outputer(WEEKLY, $week, false);

	// ------------
	// 休日
	myBootstrap::outputer(HOLIDAY, $holiday);

	// ------------
	// イベント
	myBootstrap::outputer(EVENT, $event);

}


// ================
$html .= "<a class=\"button logout\" href=\"${BASE_URL}${MY_FILE}?logout\">ログアウト</a>\n";
$html .= "<p>${mesg}</p><br />\n";
$html .= "<div class=\"areaR\"><hr><h3>サンプル</h3>\n";
$html .= "<iframe src=\"${BASE_URL}?$ymd[0]\" name=\"sample\" width=\"210\" height=\"240\" style=\"border:none;\">サンプル</iframe>";
// ----------------
$html .= "<form action=\"${MY_FILE}?$ymd[0]\" method=\"post\" enctype=\"multipart/form-data\">\n";
// ----------------
$html .= "<hr><h3>設定月</h3>\n";
$html .= "<a href=\"?$ymd[4]\" class=\"button\">${ymd[6]}月</a>\n";
$html .= "&nbsp;<b>$ymd[1]</b>年<b>$ymd[2]</b>月&nbsp;\n";
$html .= "<a href=\"?$ymd[5]\" class=\"button\">${ymd[7]}月</a></td></tr>\n";
// ----------------
$html .= "<hr><h3>週休設定</h3>\n";
foreach( $weekly as $key => $val ){
	$tmp = $key + 1;
	$html .= "<input type=\"checkbox\" name=\"week$tmp\" value=\"$tmp\"";
	if( isset($week[$tmp]) ) $html .= " checked=\"checked\"";
	$html .= ">${val}曜&nbsp;\n";
}
$html .= "<input type=\"submit\" name=\"upd\" value=\"更新\">\n";
// ----------------
$html .= "<hr><h3>休日設定</h3>\n";
$min = ($ymd[0] * 100);
foreach( $holiday as $key => $val ){
	if( $key <= $min || $key >= ($min + 100) ) continue;
	$html .= "<input type=\"submit\" name=\"del${key}\" value=\"削除\">&nbsp;${key}&nbsp;${val}<br />\n";
}
// ----------------
$html .= "<hr><h3>イベント設定</h3>\n";
foreach( $event as $key => $val ){
	if( $key <= $min || $key >= ($min + 100) ) continue;
	$html .= "<input type=\"submit\" name=\"evd${key}\" value=\"削除\">&nbsp;${key}&nbsp;${val}<br />\n";
}
// ----------------
$html .= "<hr><h3>汎用モード</h3>\n";
if( empty($_POST["select"]) || "H" == $_POST["select"] ){ $tmp = " checked=\"checked\""; }else{ $tmp = ""; }
$html .= "<input type=\"radio\" name=\"select\" value=\"H\"$tmp>休日\n";
if( !empty($_POST["select"]) && "E" == $_POST["select"] ){ $tmp = " checked=\"checked\""; }else{ $tmp = ""; }
$html .= "<input type=\"radio\" name=\"select\" value=\"E\"$tmp>イベント<br />\n";
// ----------------
$tmp = "&nbsp;<span class=\"topic\">*汎用モードが適用されます</span>";
// ----------------
$html .= "<hr><h3>自由入力$tmp</h3>\n";
$html .= "日付:<input type=\"number\" name=\"target\" placeholder=\"8桁の数字\" min=\"${min}\" size=\"10\" maxlength=\"8\">&nbsp;\n";
$html .= "ｺﾒﾝﾄ:<input type=\"text\" name=\"memo\" placeholder=\"全角５文字推奨\" size=\"16\" maxlength=\"14\">&nbsp;\n";
$html .= "<input type=\"submit\" name=\"add\" value=\"追加\"><br />\n";
// ----------------
$html .= "<hr><h3>インポート設定$tmp</h3>\n";
$html .= "<input type=\"file\" name=\"datafile\">";
$html .= "<input type=\"submit\" name=\"import\" value=\"登録\"><br />\n";

// ----------------
$html .= "</form><br />\n";
$html .= "</div>\n";
// ----------------



echo $html;



// Text by Exist-Zero,Inc.
// 2017/01/01
?>
